﻿using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;

namespace MultiSurfaceChartApp
{
    public class DataCollection : DataShape3D
    {
        public DataCollection()
        {
        }

        public void Update(int index, double val)
        {
            this.ToList().Find(p => p.Index == index).Z = val;
            OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        public List<DataPoint3D> ListXIndexPoints(double xStartInterval, double xEndInterval)
        {
            return this.ToList().FindAll(p => p.X >= xStartInterval && p.X <= xEndInterval);
        }

        public List<DataPoint3D> ListYIndexPoints(double yStartInterval, double yEndInterval)
        {
            return this.ToList().FindAll(p => p.Y >= yStartInterval && p.Y <= yEndInterval);
        }

        public List<DataPoint3D> ListSelectedPoints(List<int> selectedPointsIndexes)
        {
            List<DataPoint3D> points = new List<DataPoint3D>();

            foreach (int i in selectedPointsIndexes)
            {
                points.Add(this.ToList().Find(p => p.Index == i));
            }

            return points;
        }

        public void Update(List<DataPoint3D> newPoints)
        {
            foreach (DataPoint3D point in newPoints)
            {
                this.ToList().Find(p => p.Index == point.Index).Z = point.Z;
            }

            OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        public void SetPoints(List<DataPoint3D> newPoints)
        {
            foreach (DataPoint3D point in newPoints)
            {
                this.Add(point);
            }

            OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        public void UpdateRange()
        { }
    }
}
